{
    inputs = {
        nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";
        flake-utils.url = "github:numtide/flake-utils";
    };
    outputs = { nixpkgs, flake-utils, ... }:  flake-utils.lib.eachDefaultSystem (system: let pkgs = import nixpkgs { inherit system; }; in {
      devShells = let 
        mkShell = pkgs.mkShell.override { stdenv = pkgs.clangStdenv; }; 
        go = pkgs.go; 
        cilium-ebpf = pkgs.buildGoModule {
            name = "cilium-ebpf";
            version = "0.11.0";

            src = pkgs.fetchFromGitHub {
                owner = "cilium";
                repo = "ebpf";
                rev = "v0.11.0";
                sha256 = "+radPnp1l7OUYCEMvuVQU26V4o57R9cQkiU6khfdHAc=";
            };
            vendorSha256 = "qt6cXgU7lSw84F4/opvNnrsVU9LvjdT+LvEvaFL9CTQ=";

            doCheck = false; 
            doInstallCheck = false;
        };
      in {
        default = mkShell {
            buildInputs = with pkgs; [
                bpftool
                go
                cilium-ebpf
            ];
        };
      };
    });
}